
A = [110,220,440,880,1760]
As= [117,233,466,932,1865]
B = [123,247,494,988,1976]
C = [131,262,523,1047,2093]
Cs= [139,277,554,1109,2217]
D = [147,294,587,1175,2349]
Ds= [156,311,622,1245,2489]
E = [165,330,659,1319,2637]
F = [175,349,698,1397,2794]
Fs= [185,370,740,1480,2960]
G = [196,392,784,1568,3136]
Gs =[208,415,831,1661,3322]

lets = ["A","As","B","C","Cs","D","Ds","E","F","Fs","G","Gs"]

#===============

hz = {
	tuple(A):["A",2],
	tuple(As):["As",2],
	tuple(B):["B",2],
	tuple(C):["C",3],
	tuple(Cs):["Cs",3],
	tuple(D):["D",3],
	tuple(Ds):["Ds",3],
	tuple(E):["E",3],
	tuple(F):["F",3],
	tuple(Fs):["Fs",3],
	tuple(G):["G",3],
	tuple(Gs):["Gs",3]
}

def getHz(f, o=1.0, t=""): # f = passed frequency / o = offset ("window" the Hz is allowed to be in), t=type of return "" = nothing n="-" i="info"
    #pull in the global Hz dict
    #global hz
    # set up a position in array variable
    position = 0
    # cycle through the tuples in the Hz dict
    add = 40 # seems to be 40 under all the time(?)
    for vals in hz:
        # cycle through the individual Note Hz's in the vals Tuple
        for freq in vals: # cycle through each individual Hz value in the array (tuple)
            # check to see if the f(requency) passed is "inside" an acceptable range for that note
            if freq-o <= f <= freq+o:
                # if the f is inside the range, but not "bang on" then create a "~" char
                if int(f) != int(freq):
                    n="~"
                else:
                    n=""
                # return the info on the successful note passed
                if t=="n":
                    return("{}{}".format(hz[vals][0], n)) # just the note & tild (if not bang on)
                else:
                    return("f={}Hz is {}{}{}".format(f, hz[vals][0], position+hz[vals][1], n)) # pass full infor back
            # this f isn't here, so move to the next position
            position+=1
        # we're out of this note's range, so ontot the next note (reset the counter (position in next note array = 0))
        position=0
    # we've not found the passed f in any array, so the note isn't viable
    if t=="n":
        return("-") # pass back single char "'-"'" (no note)
    elif t=="i":
        return("{} not in Hz".format(int(f)))  # pass back info
    else:
        return("")


def quickFind(note, info=False):
    for k, v in hz.items():
        if note in k:
            if info:
                return("{}hz={}{}".format(note, v[0], k.index(note)+v[1]))
            else:
                return(v[0])
        else:
            pass
